Index: CKEditor/branches/versions/3.3.x/_source/plugins/find/dialogs/find.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/find/dialogs/find.js	(revision 5378)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/find/dialogs/find.js	(revision 5388)
@@ -6,5 +6,5 @@
 (function()
 {
-	function guardDomWalkerNonEmptyTextNode( node )
+	function nonEmptyText( node )
 	{
 		return ( node.type == CKEDITOR.NODE_TEXT && node.getLength() > 0 );
@@ -14,9 +14,8 @@
 	 * Elements which break characters been considered as sequence.
 	*/
-	function checkCharactersBoundary ( node )
+	function nonCharactersBoundary ( node )
 	{
-		var dtd = CKEDITOR.dtd;
-		return node.isBlockBoundary(
-			CKEDITOR.tools.extend( {}, dtd.$empty, dtd.$nonEditable ) );
+		return !( node.type == CKEDITOR.NODE_ELEMENT && node.isBlockBoundary(
+			CKEDITOR.tools.extend( {}, CKEDITOR.dtd.$empty, CKEDITOR.dtd.$nonEditable ) ) );
 	}
 
@@ -85,5 +84,6 @@
 			var walker =
 				new CKEDITOR.dom.walker( range );
-			walker[ 'evaluator' ] = guardDomWalkerNonEmptyTextNode;
+			walker.guard = matchWord ? nonCharactersBoundary : null;
+			walker[ 'evaluator' ] = nonEmptyText;
 			walker.breakOnFalse = true;
 
@@ -146,5 +146,5 @@
 						// Marking as match character boundaries.
 						if ( !currentTextNode
-						   && checkCharactersBoundary( this._.walker.current ) )
+						   && !nonCharactersBoundary( this._.walker.current ) )
 							this._.matchBoundary = true;
 
@@ -184,14 +184,23 @@
 			toDomRange : function()
 			{
+				var range = new CKEDITOR.dom.range( editor.document );
 				var cursors = this._.cursors;
 				if ( cursors.length < 1 )
-					return null;
-
-				var first = cursors[0],
-					last = cursors[ cursors.length - 1 ],
-					range = new CKEDITOR.dom.range( editor.document );
-
-				range.setStart( first.textNode, first.offset );
-				range.setEnd( last.textNode, last.offset + 1 );
+				{
+					var textNode = this._.walker.textNode;
+					if ( textNode )
+							range.setStartAfter( textNode );
+					else
+						return null;
+				}
+				else
+				{
+					var first = cursors[0],
+							last = cursors[ cursors.length - 1 ];
+
+					range.setStart( first.textNode, first.offset );
+					range.setEnd( last.textNode, last.offset + 1 );
+				}
+
 				return range;
 			},
@@ -823,10 +832,13 @@
 			onHide : function()
 			{
+				var range;
 				if ( finder.matchRange && finder.matchRange.isMatched() )
 				{
 					finder.matchRange.removeHighlight();
 					editor.focus();
-					editor.getSelection().selectRanges(
-						[ finder.matchRange.toDomRange() ] );
+
+					range = finder.matchRange.toDomRange();
+					if ( range )
+						editor.getSelection().selectRanges( [ range ] );
 				}
 
Index: CKEditor/branches/versions/3.3.x/_source/plugins/font/plugin.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/font/plugin.js	(revision 5378)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/font/plugin.js	(revision 5388)
@@ -30,4 +30,5 @@
 
 				styles[ name ] = new CKEDITOR.style( styleDefinition, vars );
+				styles[ name ]._.definition.name = name;
 			}
 			else
@@ -56,5 +57,5 @@
 
 						// Add the tag entry to the panel list.
-						this.add( name, '<span style="font-' + styleType + ':' + values[ i ] + '">' + name + '</span>', name );
+						this.add( name, styles[ name ].buildPreview(), name );
 					}
 				},
Index: CKEditor/branches/versions/3.3.x/_source/plugins/forms/dialogs/checkbox.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/forms/dialogs/checkbox.js	(revision 5378)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/forms/dialogs/checkbox.js	(revision 5388)
@@ -93,14 +93,14 @@
 							else
 							{
-								if ( CKEDITOR.env.ie ) 
-								{ 
-									// Remove attribute 'value' of checkbox #4721. 
-									var checkbox = new CKEDITOR.dom.element( 'input' ); 
-									element.copyAttributes( checkbox, { value: 1 } ); 
-									checkbox.replace( element ); 
-									editor.getSelection().selectElement( checkbox ); 
-									data.element = checkbox;      
-								} 
-								else 
+								if ( CKEDITOR.env.ie )
+								{
+									// Remove attribute 'value' of checkbox #4721.
+									var checkbox = new CKEDITOR.dom.element( 'input', element.getDocument() );
+									element.copyAttributes( checkbox, { value: 1 } );
+									checkbox.replace( element );
+									editor.getSelection().selectElement( checkbox );
+									data.element = checkbox;
+								}
+								else
 									element.removeAttribute( 'value' );
 							}
Index: CKEditor/branches/versions/3.3.x/_source/plugins/image/dialogs/image.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/image/dialogs/image.js	(revision 5378)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/image/dialogs/image.js	(revision 5388)
@@ -114,6 +114,11 @@
 	var switchLockRatio = function( dialog, value )
 	{
-		var oImageOriginal = dialog.originalElement,
-			ratioButton = CKEDITOR.document.getById( 'btnLockSizes' );
+		var oImageOriginal = dialog.originalElement;
+
+		// Dialog may already closed. (#5505)
+		if( !oImageOriginal )
+			return;
+
+		var ratioButton = CKEDITOR.document.getById( 'btnLockSizes' );
 
 		if ( oImageOriginal.getCustomData( 'isReady' ) == 'true' )
@@ -1052,5 +1057,5 @@
 											html : '<div>' + CKEDITOR.tools.htmlEncode( editor.lang.common.preview ) +'<br>'+
 											'<div id="ImagePreviewLoader" style="display:none"><div class="loading">&nbsp;</div></div>'+
-											'<div id="ImagePreviewBox">'+
+											'<div id="ImagePreviewBox"><table><tr><td>'+
 											'<a href="javascript:void(0)" target="_blank" onclick="return false;" id="previewLink">'+
 											'<img id="previewImage" alt="" /></a>' +
@@ -1059,5 +1064,5 @@
 											'Maecenas feugiat consequat diam. Maecenas metus. Vivamus diam purus, cursus a, commodo non, facilisis vitae, '+
 											'nulla. Aenean dictum lacinia tortor. Nunc iaculis, nibh non iaculis aliquam, orci felis euismod neque, sed ornare massa mauris sed velit. Nulla pretium mi et risus. Fusce mi pede, tempor id, cursus ac, ullamcorper nec, enim. Sed tortor. Curabitur molestie. Duis velit augue, condimentum at, ultrices a, luctus ut, orci. Donec pellentesque egestas eros. Integer cursus, augue in cursus faucibus, eros pede bibendum sem, in tempus tellus justo quis ligula. Etiam eget tortor. Vestibulum rutrum, est ut placerat elementum, lectus nisl aliquam velit, tempor aliquam eros nunc nonummy metus. In eros metus, gravida a, gravida sed, lobortis id, turpis. Ut ultrices, ipsum at venenatis fringilla, sem nulla lacinia tellus, eget aliquet turpis mauris non enim. Nam turpis. Suspendisse lacinia. Curabitur ac tortor ut ipsum egestas elementum. Nunc imperdiet gravida mauris.' ) +
-											'</div></div>'
+											'</td></tr></table></div></div>'
 										}
 									]
Index: CKEditor/branches/versions/3.3.x/_source/plugins/indent/plugin.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/indent/plugin.js	(revision 5378)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/indent/plugin.js	(revision 5388)
@@ -11,4 +11,7 @@
 {
 	var listNodeNames = { ol : 1, ul : 1 };
+
+	var isNotWhitespaces = CKEDITOR.dom.walker.whitespaces( true ),
+		isNotBookmark = CKEDITOR.dom.walker.bookmark( false, true );
 
 	function setState( editor, state )
@@ -163,4 +166,9 @@
 					   followingList.getName() in listNodeNames )
 				{
+					// IE requires a filler NBSP for nested list inside empty list item,
+					// otherwise the list item will be inaccessiable. (#4476)
+					if ( CKEDITOR.env.ie && !li.getFirst( function( node ){ return isNotWhitespaces( node ) && isNotBookmark( node ); } ) )
+						li.append( range.document.createText( '\u00a0' ) );
+
 					li.append( followingList );
 				}
Index: CKEditor/branches/versions/3.3.x/_source/plugins/list/plugin.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/list/plugin.js	(revision 5378)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/list/plugin.js	(revision 5388)
@@ -39,5 +39,5 @@
 					continue;
 
-				var itemObj = { 'parent' : listNode, indent : baseIndentLevel, element : listItem };
+				var itemObj = { 'parent' : listNode, indent : baseIndentLevel, element : listItem, contents : [] };
 				if ( !grandparentNode )
 				{
@@ -56,7 +56,10 @@
 				{
 					child = listItem.getChild( j );
-					// Push inner list items with +1 indentation in the correct order.
 					if ( child.type == CKEDITOR.NODE_ELEMENT && listNodeNames[ child.getName() ] )
+						// Note the recursion here, it pushes inner list items with
+						// +1 indentation in the correct order.
 						CKEDITOR.plugins.list.listToArray( child, database, baseArray, baseIndentLevel + 1, itemObj.grandparent );
+					else
+						itemObj.contents.push( child );
 				}
 			}
@@ -88,5 +91,7 @@
 						retval.append( rootNode );
 					}
-					currentListItem = rootNode.append( item.element );
+					currentListItem = rootNode.append( item.element.clone( false, true ) );
+					for ( var i = 0 ; i < item.contents.length ; i++ )
+						currentListItem.append( item.contents[i].clone( true, true ) );
 					currentIndex++;
 				}
@@ -101,5 +106,5 @@
 					currentListItem;
 					if ( listNodeNames[ item.grandparent.getName() ] )
-						currentListItem = item.element;
+						currentListItem = item.element.clone( false, true );
 					else
 					{
@@ -111,5 +116,6 @@
 					}
 
-					item.element.moveChildren( currentListItem );
+					for ( i = 0 ; i < item.contents.length ; i++ )
+						currentListItem.append( item.contents[i].clone( true, true ) );
 
 					if ( currentListItem.type == CKEDITOR.NODE_DOCUMENT_FRAGMENT
Index: CKEditor/branches/versions/3.3.x/_source/plugins/maximize/plugin.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/maximize/plugin.js	(revision 5378)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/maximize/plugin.js	(revision 5388)
@@ -86,4 +86,20 @@
 			editor.resize( viewPaneSize.width, viewPaneSize.height, null, true );
 		};
+	}
+
+	function refreshCursor( editor )
+	{
+		if ( editor.focusManager.hasFocus )
+		{
+			var focusGrabber = editor.container.append( CKEDITOR.dom.element.createFromHtml(
+				'<span tabindex="-1" style="position:absolute; left:-10000" role="presentation"></span>' ) );
+
+			focusGrabber.on( 'focus', function()
+				{
+					editor.focus();
+				} );
+			focusGrabber.focus();
+			focusGrabber.remove();
+		}
 	}
 
@@ -191,4 +207,7 @@
 								} );
 
+							// Fixing positioning editor chrome in Firefox break design mode. (#5149)
+							CKEDITOR.env.gecko && refreshCursor( editor );
+
 							// Add cke_maximized class.
 							container.addClass( 'cke_maximized' );
@@ -243,4 +262,7 @@
 							if ( savedSelection )
 							{
+								// Fixing positioning editor chrome in Firefox break design mode. (#5149)
+								CKEDITOR.env.gecko && refreshCursor( editor );
+
 								editor.getSelection().selectRanges(savedSelection);
 								var element = editor.getSelection().getStartElement();
Index: CKEditor/branches/versions/3.3.x/_source/plugins/pagebreak/plugin.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/pagebreak/plugin.js	(revision 5378)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/pagebreak/plugin.js	(revision 5388)
@@ -94,4 +94,9 @@
 			range.splitBlock( 'p' );
 			range.insertNode( breakObject );
+			if ( i == ranges.length - 1 )
+			{
+				range.moveToPosition( breakObject, CKEDITOR.POSITION_AFTER_END );
+				range.select();
+			}
 		}
 	}
Index: CKEditor/branches/versions/3.3.x/_source/plugins/panel/plugin.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/panel/plugin.js	(revision 5378)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/panel/plugin.js	(revision 5388)
@@ -228,4 +228,7 @@
 				: this._.holder;
 
+		// Disable context menu for block panel.
+		holder.getParent().getParent().disableContextMenu();
+
 		if ( current )
 		{
Index: CKEditor/branches/versions/3.3.x/_source/plugins/pastefromword/plugin.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/pastefromword/plugin.js	(revision 5378)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/pastefromword/plugin.js	(revision 5388)
@@ -36,4 +36,6 @@
 							});
 					}
+					else
+						resetFromWord();
 				}
 			});
Index: CKEditor/branches/versions/3.3.x/_source/plugins/resize/plugin.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/resize/plugin.js	(revision 5378)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/resize/plugin.js	(revision 5388)
@@ -54,7 +54,7 @@
 						editor.document.on( 'mouseup', dragEndHandler );
 					}
-				} );
+				});
 
-			editor.on( 'destroy', function() { CKEDITOR.tools.removeFunction( mouseDownFn ) } );
+			editor.on( 'destroy', function() { CKEDITOR.tools.removeFunction( mouseDownFn ); } );
 
 			editor.on( 'themeSpace', function( event )
Index: CKEditor/branches/versions/3.3.x/_source/plugins/scayt/dialogs/options.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/scayt/dialogs/options.js	(revision 5378)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/scayt/dialogs/options.js	(revision 5388)
@@ -214,7 +214,7 @@
 
 		// Add buttons titles
-		if (userDicActive)
-		{
-			for ( i in buttons )
+		if ( userDicActive )
+		{
+			for ( i = 0; i < buttons.length; i++ )
 			{
 				var button = buttons[ i ];
@@ -226,5 +226,5 @@
 
 		// Fill options and dictionary labels.
-		if (tags[0] == 1)
+		if ( tags[0] == 1 )
 		{
 			for ( i in labels )
Index: CKEditor/branches/versions/3.3.x/_source/plugins/scayt/plugin.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/scayt/plugin.js	(revision 5378)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/scayt/plugin.js	(revision 5388)
@@ -42,10 +42,15 @@
 			oParams.srcNodeRef = editor.document.getWindow().$.frameElement;
 			// syntax : AppName.AppVersion@AppRevision
-			oParams.assocApp  = "CKEDITOR." + CKEDITOR.version + "@" + CKEDITOR.revision;
-			oParams.customerid = editor.config.scayt_customerid  || "1:WvF0D4-UtPqN1-43nkD4-NKvUm2-daQqk3-LmNiI-z7Ysb4-mwry24-T8YrS3-Q2tpq2";
+			oParams.assocApp  = 'CKEDITOR.' + CKEDITOR.version + '@' + CKEDITOR.revision;
+			oParams.customerid = editor.config.scayt_customerid  || '1:WvF0D4-UtPqN1-43nkD4-NKvUm2-daQqk3-LmNiI-z7Ysb4-mwry24-T8YrS3-Q2tpq2';
 			oParams.customDictionaryIds = editor.config.scayt_customDictionaryIds || '';
 			oParams.userDictionaryName = editor.config.scayt_userDictionaryName || '';
-			oParams.sLang = editor.config.scayt_sLang || "en_US";
-			
+			oParams.sLang = editor.config.scayt_sLang || 'en_US';
+
+			oParams.onBeforeChange = function()
+			{
+				if ( !editor.checkDirty() )
+					setTimeout( function(){ editor.resetDirty(); } );
+			};
 
 			var scayt_custom_params = window.scayt_custom_params;
@@ -57,8 +62,8 @@
 				}
 			}
-			
+			// needs for restoring a specific scayt control settings
 			if ( scayt_control_id )
 				oParams.id = scayt_control_id;
-			
+
 			var scayt_control = new window.scayt( oParams );
 
@@ -113,10 +118,11 @@
 				if ( (ev.data.name == 'source' ||  ev.data.name == 'newpage') && editor.mode == 'wysiwyg' )
 				{
-					var scayt_instanse = plugin.getScayt( editor );
-					if ( scayt_instanse )
-					{
-						scayt_paused = scayt_instanse.paused = !scayt_instanse.disabled;
-						scayt_control_id = scayt_instanse.id;
-						scayt_instanse.destroy( true );
+					var scayt_instance = plugin.getScayt( editor );
+					if ( scayt_instance )
+					{
+						scayt_paused = scayt_instance.paused = !scayt_instance.disabled;
+						// store a control id for restore a specific scayt control settings
+						scayt_control_id = scayt_instance.id;
+						scayt_instance.destroy( true );
 						delete plugin.instances[ editor.name ];
 					}
@@ -124,15 +130,19 @@
 			});
 
-
-		editor.on( 'destroy', function()
-			{
-				scayt_control_id = scayt_instanse.id;
-				plugin.getScayt( editor ).destroy( true );
+		editor.on( 'destroy', function( ev )
+			{
+				var editor = ev.editor,
+					scayt_instance = plugin.getScayt( editor );
+				// store a control id for restore a specific scayt control settings
+				scayt_control_id = scayt_instance.id;
+				scayt_instance.destroy( true );
+				delete plugin.instances[ editor.name ];
 			});
+
 		// Listen to data manipulation to reflect scayt markup.
 		editor.on( 'afterSetData', function()
 			{
 				if ( plugin.isScaytEnabled( editor ) ) {
-					window.setTimeout( function(){ plugin.getScayt( editor ).refresh() }, 10 );
+					window.setTimeout( function(){ plugin.getScayt( editor ).refresh(); }, 10 );
 				}
 			});
@@ -150,5 +160,5 @@
 
 					// Swallow any SCAYT engine errors.
-					window.setTimeout( function(){ scayt_instance.refresh() }, 10 );
+					window.setTimeout( function(){ scayt_instance.refresh(); }, 10 );
 				}
 			}, this, null, 50 );
@@ -156,5 +166,4 @@
 		editor.on( 'insertHtml', function()
 			{
-
 				var scayt_instance = plugin.getScayt( editor );
 				if ( plugin.isScaytEnabled( editor ) )
@@ -166,7 +175,5 @@
 
 					// Swallow any SCAYT engine errors.
-					
-					window.setTimeout( function(){ scayt_instance.refresh() },10 );
-					
+					window.setTimeout( function(){ scayt_instance.refresh(); },10 );
 				}
 			}, this, null, 50 );
@@ -182,4 +189,5 @@
 		var dataProcessor = editor.dataProcessor,
 			htmlFilter = dataProcessor && dataProcessor.htmlFilter;
+
 		if ( htmlFilter )
 		{
@@ -220,6 +228,6 @@
 		isScaytEnabled : function( editor )
 		{
-			var scayt_instanse = this.getScayt( editor );
-			return ( scayt_instanse ) ? scayt_instanse.disabled === false : false;
+			var scayt_instance = this.getScayt( editor );
+			return ( scayt_instance ) ? scayt_instance.disabled === false : false;
 		},
 		loadEngine : function( editor )
@@ -227,9 +235,10 @@
 			// SCAYT doesn't work with Opera.
 			if ( CKEDITOR.env.opera )
-				return;
+				return null;
+
 			if ( this.engineLoaded === true )
 				return onEngineLoad.apply( editor );	// Add new instance.
 			else if ( this.engineLoaded == -1 )			// We are waiting.
-				return CKEDITOR.on( 'scaytReady', function(){ onEngineLoad.apply( editor );} );	// Use function(){} to avoid rejection as duplicate.
+				return CKEDITOR.on( 'scaytReady', function(){ onEngineLoad.apply( editor ); } );	// Use function(){} to avoid rejection as duplicate.
 
 			CKEDITOR.on( 'scaytReady', onEngineLoad, editor );
@@ -240,5 +249,5 @@
 				this,
 				null,
-				0 
+				0
 			);	// First to run.
 
@@ -249,8 +258,8 @@
 			// Default to 'http' for unknown.
 			protocol = protocol.search( /https?:/) != -1? protocol : 'http:';
-			var baseUrl  = "svc.spellchecker.net/spellcheck31/lf/scayt/scayt22.js";
-
-			var scaytUrl  =  editor.config.scayt_srcUrl || ( protocol + "//" + baseUrl );
-			var scaytConfigBaseUrl =  plugin.parseUrl( scaytUrl ).path +  "/";
+			var baseUrl  = 'svc.spellchecker.net/spellcheck31/lf/scayt/scayt22.js';
+
+			var scaytUrl  =  editor.config.scayt_srcUrl || ( protocol + '//' + baseUrl );
+			var scaytConfigBaseUrl =  plugin.parseUrl( scaytUrl ).path +  '/';
 
 			CKEDITOR._djScaytConfig =
@@ -261,5 +270,5 @@
 					function()
 					{
-						CKEDITOR.fireOnce( "scaytReady" );
+						CKEDITOR.fireOnce( 'scaytReady' );
 					}
 				],
@@ -361,13 +370,13 @@
 			CKEDITOR.dialog.add( commandName, CKEDITOR.getUrl( this.path + 'dialogs/options.js' ) );
 			// read ui tags
-			var confuiTabs = editor.config.scayt_uiTabs || "1,1,1";
+			var confuiTabs = editor.config.scayt_uiTabs || '1,1,1';
 			var uiTabs =[];
-			// string tp array convert
-			confuiTabs = confuiTabs.split(",");
-			// check array length ! allwaays must be 3 filled with 1 or 0
+			// string to array convert
+			confuiTabs = confuiTabs.split( ',' );
+			// check array length ! always must be 3 filled with 1 or 0
 			for (var i=0,l=3; i<l; i++)
 			{
-				var flag = parseInt(confuiTabs[i] || "1" ,10);
-				uiTabs.push(  flag  );
+				var flag = parseInt(confuiTabs[i] || '1' ,10);
+				uiTabs.push( flag );
 			}
 
@@ -377,5 +386,5 @@
 			var uiMuneItems = {};
 
-			// allways added
+			// always added
 			uiMuneItems.scaytToggle =
 				{
@@ -419,5 +428,5 @@
 					}
 				};
-			// allways added
+			// always added
 			uiMuneItems.scaytAbout =
 				{
@@ -432,5 +441,5 @@
 			;
 
-			uiTabs[3] = 1; // about us tab is allways on
+			uiTabs[3] = 1; // about us tab is always on
 			plugin.uiTabs = uiTabs;
 
@@ -476,5 +485,5 @@
 						var scayt_control = plugin.getScayt( editor ),
 							node = scayt_control.getScaytNode();
-						
+
 						if ( !node )
 							return null;
@@ -504,5 +513,5 @@
 						mainSuggestions = {};
 
-						var moreSuggestionsUnable = editor.config.scayt_moreSuggestions || "on";
+						var moreSuggestionsUnable = editor.config.scayt_moreSuggestions || 'on';
 						var moreSuggestionsUnableAdded = false;
 
@@ -511,6 +520,6 @@
 						!maxSuggestions && ( maxSuggestions = items_suggestion.length );
 
-						var contextCommands = editor.config.scayt_contextCommands || "all";
-						contextCommands = contextCommands.split("|");
+						var contextCommands = editor.config.scayt_contextCommands || 'all';
+						contextCommands = contextCommands.split( '|' );
 
 						for ( var i = 0, l = items_suggestion.length; i < l; i += 1 )
@@ -534,5 +543,5 @@
 								mainSuggestions[ commandName ] = CKEDITOR.TRISTATE_OFF;
 							}
-							else if ( moreSuggestionsUnable == "on" )
+							else if ( moreSuggestionsUnable == 'on' )
 							{
 								addButtonCommand( editor, 'button_' + commandName, items_suggestion[i],
@@ -543,6 +552,7 @@
 						}
 
-						if ( moreSuggestionsUnableAdded ){
-							// Rgister the More suggestions group;
+						if ( moreSuggestionsUnableAdded )
+						{
+							// Register the More suggestions group;
 							editor.addMenuItem( 'scayt_moresuggest',
 							{
@@ -556,8 +566,7 @@
 							});
 							mainSuggestions[ 'scayt_moresuggest' ] = CKEDITOR.TRISTATE_OFF;
-
-						}
-
-						if ( in_array( "all",contextCommands )  || in_array("ignore",contextCommands)  )
+						}
+
+						if ( in_array( 'all', contextCommands )  || in_array( 'ignore', contextCommands)  )
 						{
 							var ignore_command = {
@@ -566,9 +575,9 @@
 								}
 							};
-							addButtonCommand(editor, 'ignore', editor.lang.scayt.ignore, 'scayt_ignore', ignore_command, 'scayt_control', 1);
-							mainSuggestions['scayt_ignore'] = CKEDITOR.TRISTATE_OFF;
-						}
-
-						if ( in_array( "all",contextCommands )  || in_array("ignoreall",contextCommands)  )
+							addButtonCommand( editor, 'ignore', editor.lang.scayt.ignore, 'scayt_ignore', ignore_command, 'scayt_control', 1 );
+							mainSuggestions[ 'scayt_ignore' ] = CKEDITOR.TRISTATE_OFF;
+						}
+
+						if ( in_array( 'all', contextCommands )  || in_array( 'ignoreall', contextCommands ) )
 						{
 							var ignore_all_command = {
@@ -581,5 +590,5 @@
 						}
 
-						if ( in_array( "all",contextCommands )  || in_array("add",contextCommands)  )
+						if ( in_array( 'all', contextCommands )  || in_array( 'add', contextCommands ) )
 						{
 							var addword_command = {
@@ -608,10 +617,16 @@
 				};
 				editor.on( 'showScaytState', showInitialState );
-				plugin.loadEngine( editor );
-			}
-
+				editor.on( 'instanceReady', function()
+				{
+					plugin.loadEngine( editor );
+				});
+			}
+		},
+
+		afterInit : function( editor )
+		{
 			// Prevent word marker line from displaying in elements path. (#3570)
 			var elementsPathFilters;
-			if ( elementsPathFilters = editor.config.elementsPath_filters )
+			if ( editor._.elementsPath && ( elementsPathFilters = editor._.elementsPath.filters ) )
 			{
 				elementsPathFilters.push( function( element )
@@ -657,5 +672,5 @@
 
 /**
- * Sets the customer ID for SCAYT. Required for migration from free version 
+ * Sets the customer ID for SCAYT. Required for migration from free version
  * with banner to paid version.
  * @name CKEDITOR.config.scayt_customerid
@@ -733,5 +748,5 @@
 /**
  * Links SCAYT to custom dictionaries. It's a string containing dictionary ids
- * separared by commas (","). Available only for licensed version. 
+ * separared by commas (","). Available only for licensed version.
  * Further details at http://wiki.spellchecker.net/doku.php?id=custom_dictionary_support .
  * @name CKEDITOR.config.scayt_customDictionaryIds
@@ -751,3 +766,2 @@
  * config.scayt_userDictionaryName = 'MyDictionary';
  */
-
Index: CKEditor/branches/versions/3.3.x/_source/plugins/selection/plugin.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/selection/plugin.js	(revision 5378)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/selection/plugin.js	(revision 5388)
@@ -162,4 +162,14 @@
 								saveEnabled = false;
 							});
+
+						// IE before version 8 will leave cursor blinking inside the document after
+						// editor blurred unless we clean up the selection. (#4716)
+						if ( CKEDITOR.env.ie && CKEDITOR.env.version < 8 )
+						{
+							doc.getWindow().on( 'blur', function( evt )
+							{
+								editor.document.$.selection.empty();
+							});
+						}
 
 						// IE fires the "selectionchange" event when clicking
@@ -754,5 +764,5 @@
 					}
 				});
-			
+
 			return cache.selectedElement = ( node ? new CKEDITOR.dom.element( node ) : null );
 		},
@@ -1086,4 +1096,5 @@
 					ieRange.select();
 
+				this.moveToPosition( dummySpan, CKEDITOR.POSITION_BEFORE_START );
 				dummySpan.remove();
 			}
@@ -1094,5 +1105,5 @@
 				ieRange.select();
 			}
-			
+
 			this.document.fire( 'selectionchange' );
 		}
Index: CKEditor/branches/versions/3.3.x/_source/plugins/smiley/dialogs/smiley.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/smiley/dialogs/smiley.js	(revision 5378)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/smiley/dialogs/smiley.js	(revision 5388)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
Index: CKEditor/branches/versions/3.3.x/_source/plugins/specialchar/dialogs/specialchar.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/specialchar/dialogs/specialchar.js	(revision 5378)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/specialchar/dialogs/specialchar.js	(revision 5388)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
@@ -12,5 +12,5 @@
 	var dialog,
 		lang = editor.lang.specialChar;
-	
+
 	var insertSpecialChar = function ( specialChar )
 	{
@@ -18,22 +18,22 @@
 			ranges	  = selection.getRanges(),
 			range, textNode;
-				
+
 		editor.fire( 'saveSnapshot' );
-		
+
 		for ( var i = 0, len = ranges.length ; i < len ; i++ )
 		{
 			range = ranges[ i ];
 			range.deleteContents();
-			
+
 			textNode =  CKEDITOR.dom.element.createFromHtml( specialChar );
 			range.insertNode( textNode );
 		}
-		
+
 		range.moveToPosition( textNode, CKEDITOR.POSITION_AFTER_END );
 		range.select();
-		
+
 		editor.fire( 'saveSnapshot' );
 	};
-	
+
 	var onChoice = function( evt )
 	{
@@ -48,5 +48,5 @@
 			target.removeClass( "cke_light_background" );
 			dialog.hide();
-			
+
 			// Firefox has bug on insert chars into a element use its own API. (#5170)
 			if ( CKEDITOR.env.gecko )
@@ -291,5 +291,5 @@
 
 						html.push(
-							'<td class="cke_dark_background" style="cursor: default">' +
+							'<td class="cke_dark_background" style="cursor: default" role="presentation">' +
 							'<a href="javascript: void(0);" role="option"' +
 							' aria-posinset="' + ( i +1 ) + '"',
